package LoadTester.CPU;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

public class CPULoadTester extends JFrame{
  private final Dimension SIZE = new Dimension( 300, 170 );
  private final int   perMIN  = 0;
  private final int   perMAX  = 10;
  private final int   perINIT = 0;
  private final int   intINIT = 100;
  private JSlider     perSlider;
  private JLabel      perText;
  private JTextField  tfInt;
  private JLabel      lbInt;
  private LoadThread  Loadth;

  public static void main( String args[] ){
    CPULoadTester clm = new CPULoadTester( "CPU Load Tester 1.0" );
  }
  public CPULoadTester( String title ){
    super( title );
    try{
      BufferedReader br = new BufferedReader( new FileReader( "init.txt" ) );
      int load1 = Integer.parseInt( br.readLine() );
      int load2 = Integer.parseInt( br.readLine() );
      Loadth = new LoadThread( load1, load2 );
      Loadth.setPriority( Thread.MAX_PRIORITY );
      Loadth.start();

      Runtime.getRuntime().addShutdownHook(new Shutdown());
      JPanel pane = ( JPanel )getContentPane();
      JPanel p1 = new JPanel( new BorderLayout() );
      JPanel p2 = new JPanel( new GridLayout(1,3,5,5) );
      JPanel p3 = new JPanel( new GridLayout(2,3,3,3) );
      p3.setBorder(new TitledBorder("݂̐ݒ"));
      perSlider   = new JSlider( perMIN, perMAX, perINIT );
      perSlider.addChangeListener( new SliderListener() );

      perText     = new JLabel( String.valueOf( perINIT ) + "%", JLabel.RIGHT);
      perText.setForeground( Color.black );
      perText.setFont( new Font( "SansSerif", Font.PLAIN, 24 ) );

      JLabel text = new JLabel( "CPUח" );
      text.setForeground( Color.black );
      text.setFont( new Font( "SansSerif", Font.PLAIN, 24 ) );

      JLabel lb  = new JLabel("Interval(ms)", JLabel.CENTER);
      tfInt      = new JTextField( String.valueOf(intINIT) );
      tfInt.setHorizontalAlignment(SwingConstants.RIGHT);
      JButton bt = new JButton( new SetAction() );
      
      JLabel lb1 = new JLabel("Interval", JLabel.CENTER);
      JLabel lb2 = new JLabel("Load1", JLabel.CENTER);
      JLabel lb3 = new JLabel("Load2", JLabel.CENTER);
      lbInt      = new JLabel(String.valueOf(intINIT), JLabel.CENTER);
      JLabel lb5 = new JLabel(String.valueOf(load1), JLabel.CENTER);
      JLabel lb6 = new JLabel(String.valueOf(load2), JLabel.CENTER);
      p1.add( text,    BorderLayout.CENTER );
      p1.add( perText, BorderLayout.EAST );
      p1.add( perSlider, BorderLayout.SOUTH );
      p2.add( lb );
      p2.add( tfInt );
      p2.add( bt );
      p3.add( lb1 );
      p3.add( lb2 );
      p3.add( lb3 );
      p3.add( lbInt );
      p3.add( lb5 );
      p3.add( lb6 );
      pane.add( p1,        BorderLayout.NORTH  );
      pane.add( p3,        BorderLayout.CENTER  );
      pane.add( p2,        BorderLayout.SOUTH  );
      
    }catch( Exception ex ){
      JOptionPane.showMessageDialog(getContentPane(),"t@CُłB\nInitializerNݒ肵Ă");
      System.exit(0);
    }
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    setSize( SIZE );
    setVisible( true );
  }
  class SliderListener implements ChangeListener{
    public void stateChanged( ChangeEvent e ){
      int val = perSlider.getValue()*(100/perMAX);
      Loadth.setLoad( val );
      perText.setText( String.valueOf( val ) + "%" );
    }
  }
  class SetAction extends AbstractAction{
    public SetAction(){
      putValue( Action.NAME, "ݒ");
    }
    public void actionPerformed( ActionEvent e ){
      int interval = Integer.parseInt( tfInt.getText() );
      Loadth.setInterval( interval );
      lbInt.setText( String.valueOf(interval) );
    }
  }
  class Shutdown extends Thread{
    public void run(){
      Loadth.stopLoop();
    }
  }
}
